01背包--hdu2639

hdu-2639

The title of this problem is familiar,isn't it?yeah,if you had took part in the "Rookie Cup" competition,you must have seem this title.If you haven't seen it before,it doesn't matter,I will give you a link:

Here is the link:http://acm.hdu.edu.cn/showproblem.php?pid=2602

Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.

If the total number of different values is less than K,just ouput 0.

Input

The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.

Output

One integer per line representing the K-th maximum of the total value (this number will be less than 231).

Sample Input

3
5 10 2
1 2 3 4 5
5 4 3 2 1
5 10 12
1 2 3 4 5
5 4 3 2 1
5 10 16
1 2 3 4 5
5 4 3 2 1

Sample Output

12
2
0

题目大意

n块骨头,V容量的背包,把骨头放进包里,求价值第k大时是多少。

思路

就是个01背包的变种,根据dp思想,在01背包的基础上加多一个维度,dp[j][k]表示容量为j的背包下,第k大的价值。

首先考虑第1大的数,是max(dp[i][j], dp[i - 1][j - c[i]] + w[i])

可以推断,第k大的值可以在两组数dp[i][j][z]、dp[i - 1][j - c[i]][z] + w[i],z∈[1, ... , k]中得到

然而并不能直接知道这两组数中前k大的数,所以将dp[i][j][z]放入A[],将dp[i - 1][j - c[i]][z] + w[i]放入B[]

然后将A[]、B[]两组数一起排序,就能得到第k大的数

代码

#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <cstdio>

using namespace std;

typedef long long LL;
const int N = 1005;
const int INF = 0x3f3f3f3f;
const int MOD = 1e9 + 7;

int main()
{
    int T;
    cin >> T;
    while(T--)
    {
        LL n, V, K;
        cin >> n >> V >> K;
        LL w[N], c[N];
        for(int i = 1;i <= n;++i)
            cin >> w[i];
        for(int i = 1;i <= n;++i)
            cin >> c[i];

        LL dp[N][35];
        memset(dp, 0, sizeof(dp));
        for(int i = 1;i <= n;++i)
        {
            for(int j = V;j >= c[i];--j)
            {
                LL A[35], B[35];
                int a, b, num;
                for(int k = 1;k <= K;++k)
                {
                    A[k] = dp[j - c[i]][k] + w[i];
                    B[k] = dp[j][k];
                }
                A[K + 1] = B[K + 1] = -1;//-1 < 0。a <= K做判断条件会出错
                a = b = num = 1;
                while(num <= K && (A[a] != -1 || B[b] != -1))
                {
                    if(A[a] > B[b])
                        dp[j][num] = A[a++];
                    else
                        dp[j][num] = B[b++];
                    if(dp[j][num] != dp[j][num - 1])
                        num++;
                }
            }
        }
        cout << dp[V][K] << endl;
    }
    return 0;
}

转载于:https://www.cnblogs.com/shuizhidao/p/10310198.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值